/*
** vbcc-PowerOpen/WarpOS Lowlevel close() function
**
** v0.1 31.07.98 phx
*/

#include <stdio.h>
#include <errno.h>

#include <powerpc/powerpc.h>
#include <clib/powerpc_protos.h>

extern APTR DOSBase;


int _close(char *fh)
{
  struct PPCArgs pa;

  if (!fh) {
    errno = EBADF;
    return (-1);
  }
  pa.PP_Code = DOSBase;
  pa.PP_Offset = -36;  /* _LVOClose */
  pa.PP_Flags = pa.PP_StackSize = 0;
  pa.PP_Stack = NULL;
  pa.PP_Regs[PPREG_D1] = (ULONG)fh;
  pa.PP_Regs[PPREG_A6] = (ULONG)DOSBase;
  Run68k(&pa);
  if (!pa.PP_Regs[PPREG_D0]) {
    errno = EIO;
    return (-1);
  }
  return (0);
}
